/*
	Preparation Date : 2014-09-24
	Preparation By   : Rahmat
	Description      : Get PR/PO monitoring data
*/

CREATE PROCEDURE [dbo].[SP_DLV_PO_Monitoring]

@vPO_MONTH VARCHAR (MAX),
@vPR_NO	VARCHAR (MAX),
@vPR_STATUS	VARCHAR (MAX),
@vPR_DATE	VARCHAR (MAX),
@vPO_NO	VARCHAR (MAX),
@vPO_STATUS	VARCHAR (MAX),
@vPO_DATE	VARCHAR (MAX),
@vLOG_PARTNER_NAME	VARCHAR (MAX)


AS
BEGIN
	
	DECLARE @QUERY VARCHAR (MAX);


	CREATE TABLE #TEMP_MONITORING (
		PR_SH_APPROVED_DT VARCHAR (20), PR_DPH_APPROVED_DT	VARCHAR (20), PR_DH_APPROVED_DT	VARCHAR (20),
		PO_SH_APPROVED_DT	VARCHAR (20), PO_DPH_APPROVED_DT	VARCHAR (20), PO_DH_APPROVED_DT	VARCHAR (20),
		PROD_MONTH	VARCHAR (12), PR_NO VARCHAR (12), PO_NO VARCHAR (12), PDF VARCHAR (20),
		PR_SH_APPROVED_BY2 VARCHAR (20), PR_SH_APPROVED_DT2 DATETIME, PR_DPH_APPROVED_BY2 VARCHAR (20),
		PR_DPH_APPROVED_DT2 DATETIME, PR_DH_APPROVED_BY2 VARCHAR (20), PR_DH_APPROVED_DT2 DATETIME,
		PR_REJECTED_BY VARCHAR (20), PR_REJECTED_DT DATETIME, PR_REJECTED_POSITION VARCHAR(50), PR_CREATED_DT DATETIME, PR_CREATED_BY VARCHAR(50),PR_REMARK VARCHAR (MAX),
		PO_SH_APPROVED_BY2 VARCHAR (20), PO_SH_APPROVED_DT2 DATETIME, PO_DPH_APPROVED_BY2 VARCHAR (20),
		PO_DPH_APPROVED_DT2 DATETIME, PO_DH_APPROVED_BY2 VARCHAR (20), PO_DH_APPROVED_DT2 DATETIME,
		PO_REJECTED_BY VARCHAR (20), PO_REJECTED_DT DATETIME, PO_REJECTED_POSITION VARCHAR(50), PO_CREATED_DT DATETIME,PO_CREATED_BY VARCHAR(50),
		PO_REMARK VARCHAR (MAX), LP_CD VARCHAR (4), LOG_PARTNER_NAME VARCHAR (50), PO_STATUS VARCHAR (25),
		PR_STATUS VARCHAR (25), STATUS VARCHAR (2)
	);
	
	INSERT INTO #TEMP_MONITORING (
		PR_SH_APPROVED_DT,PR_DPH_APPROVED_DT,PR_DH_APPROVED_DT,PO_SH_APPROVED_DT, PO_DPH_APPROVED_DT,PO_DH_APPROVED_DT,PROD_MONTH,PR_NO ,PO_NO ,PDF,
		PR_SH_APPROVED_BY2 ,PR_SH_APPROVED_DT2 ,PR_DPH_APPROVED_BY2 ,PR_DPH_APPROVED_DT2 ,PR_DH_APPROVED_BY2 ,
		PR_DH_APPROVED_DT2 ,PR_REJECTED_BY ,PR_REJECTED_DT, PR_REJECTED_POSITION, PR_CREATED_DT , PR_CREATED_BY, PR_REMARK ,PO_SH_APPROVED_BY2 ,PO_SH_APPROVED_DT2 ,
		PO_DPH_APPROVED_BY2 ,PO_DPH_APPROVED_DT2 ,PO_DH_APPROVED_BY2 ,PO_DH_APPROVED_DT2 ,PO_REJECTED_BY ,PO_REJECTED_DT , PO_REJECTED_POSITION,
		PO_CREATED_DT , PO_CREATED_BY, PO_REMARK ,LP_CD ,LOG_PARTNER_NAME , PO_STATUS,PR_STATUS,STATUS)




SELECT DISTINCT    
--INI mulai PR
(case
	WHEN HEADPR.REJECTED_POSITION = 'SH' THEN 'red'
	WHEN NOT ISNULL(HEADPR.SH_APPROVED_DT,0)=0 AND HEADPR.REJECTED_POSITION = 'DH' THEN 'green_1'
	WHEN ISNULL(HEADPR.SH_APPROVED_DT,0)=0 AND HEADPR.REJECTED_POSITION = 'DH' THEN 'red'
	WHEN ISNULL(HEADPR.SH_APPROVED_DT,0)=0 AND HEADPR.REJECTED_POSITION = 'DPH' THEN 'red'
	WHEN NOT ISNULL(HEADPR.SH_APPROVED_DT,0)=0 AND ISNULL(HEADPR.REJECTED_DT,0)!=0 THEN 'green_1'
	WHEN NOT ISNULL(HEADPR.SH_APPROVED_DT,0)=0 AND ISNULL(HEADPR.REJECTED_DT,0)=0 THEN 'green_1' 
	WHEN ISNULL(HEADPR.SH_APPROVED_DT,0)=0 AND NOT ISNULL(HEADPR.DH_APPROVED_DT,0)=0 THEN 'green_1'
	WHEN ISNULL(HEADPR.SH_APPROVED_DT,0)=0 AND ISNULL(HEADPR.REJECTED_DT,0)=0 THEN 'yellow_1' 
	ELSE 'gray' END)  AS PR_SH_APPROVED_DT,
(case
	WHEN HEADPR.REJECTED_POSITION = 'DPH' THEN 'red'
	WHEN NOT ISNULL(HEADPR.DPH_APPROVED_DT,0)=0 AND HEADPR.REJECTED_POSITION = 'DH' THEN 'green_1'
	WHEN ISNULL(HEADPR.DPH_APPROVED_DT,0)=0 AND HEADPR.REJECTED_POSITION = 'DH' THEN 'red'
	WHEN NOT ISNULL(HEADPR.DPH_APPROVED_DT,0)=0 AND ISNULL(HEADPR.REJECTED_DT,0)=0 THEN 'green_1'
	WHEN ISNULL(HEADPR.DPH_APPROVED_DT,0)=0 AND NOT ISNULL(HEADPR.DH_APPROVED_DT,0)=0 THEN 'green_1'
	WHEN ISNULL(HEADPR.DPH_APPROVED_DT,0)=0 AND ISNULL(HEADPR.REJECTED_DT,0)=0 THEN 'yellow_1' 
	ELSE 'gray' END)  AS  PR_DPH_APPROVED_DT,
(case
	WHEN HEADPR.REJECTED_POSITION = 'DH' THEN 'red'
	WHEN NOT ISNULL(HEADPR.DH_APPROVED_DT,0)=0 AND ISNULL(HEADPR.REJECTED_DT,0)=0 THEN 'green_1' 
	WHEN ISNULL(HEADPR.DH_APPROVED_DT,0)=0 AND ISNULL(HEADPR.REJECTED_DT,0)=0 THEN 'yellow_1' 
	ELSE 'gray' END)  AS  PR_DH_APPROVED_DT,
	--Sampai Sini PR
	
	--dari sini PO


(case  
	WHEN ISNULL(DETPR.PO_NO,'') = '' AND HEADPR.PR_STATUS_FLAG <> 'PR6' THEN '0'
	WHEN NOT ISNULL(HEADPR.REJECTED_DT,0)=0 THEN 'gray'

	WHEN HEADPO.REJECTED_POSITION = 'SH' THEN 'red'
	WHEN NOT ISNULL(HEADPO.SH_APPROVED_DT,0)=0 AND HEADPO.REJECTED_POSITION = 'DH' THEN 'green_1'
	WHEN ISNULL(HEADPO.SH_APPROVED_DT,0)=0 AND HEADPO.REJECTED_POSITION = 'DH' THEN 'red'
	WHEN NOT ISNULL(HEADPO.SH_APPROVED_DT,0)=0 AND ISNULL(HEADPO.REJECTED_DT,0)!=0 THEN 'green_1'
	WHEN NOT ISNULL(HEADPO.SH_APPROVED_DT,0)=0 AND ISNULL(HEADPO.REJECTED_DT,0)=0 THEN 'green_1' 
	WHEN ISNULL(HEADPO.SH_APPROVED_DT,0)=0 AND NOT ISNULL(HEADPO.DH_APPROVED_DT,0)=0 THEN 'green_1'
	WHEN ISNULL(HEADPO.SH_APPROVED_DT,0)=0 AND ISNULL(HEADPO.REJECTED_DT,0)=0 THEN 'yellow_1' 
	ELSE 'gray' END)  AS PO_SH_APPROVED_DT,
(case
	WHEN ISNULL(DETPR.PO_NO,'') = '' AND HEADPR.PR_STATUS_FLAG <> 'PR6' THEN '0'
	WHEN NOT ISNULL(HEADPR.REJECTED_DT,0)=0 THEN 'gray'

	WHEN HEADPO.REJECTED_POSITION = 'DPH' THEN 'red'
	WHEN NOT ISNULL(HEADPO.DPH_APPROVED_DT,0)=0 AND HEADPO.REJECTED_POSITION = 'DH' THEN 'green_1'
	WHEN ISNULL(HEADPO.DPH_APPROVED_DT,0)=0 AND HEADPO.REJECTED_POSITION = 'DH' THEN 'red'
	WHEN NOT ISNULL(HEADPO.DPH_APPROVED_DT,0)=0 AND ISNULL(HEADPO.REJECTED_DT,0)=0 THEN 'green_1'
	WHEN ISNULL(HEADPO.DPH_APPROVED_DT,0)=0 AND NOT ISNULL(HEADPO.DH_APPROVED_DT,0)=0 THEN 'green_1'
	WHEN ISNULL(HEADPO.DPH_APPROVED_DT,0)=0 AND ISNULL(HEADPO.REJECTED_DT,0)=0 THEN 'yellow_1' 
	ELSE 'gray' END)  AS  PO_DPH_APPROVED_DT,
(case
	WHEN ISNULL(DETPR.PO_NO,'') = '' AND HEADPR.PR_STATUS_FLAG <> 'PR6' THEN '0'
	WHEN NOT ISNULL(HEADPR.REJECTED_DT,0)=0 THEN 'gray'

	WHEN HEADPO.REJECTED_POSITION = 'DH' THEN 'red'
	WHEN NOT ISNULL(HEADPO.DH_APPROVED_DT,0)=0 AND ISNULL(HEADPO.REJECTED_DT,0)=0 THEN 'green_1' 
	WHEN ISNULL(HEADPO.DH_APPROVED_DT,0)=0 AND ISNULL(HEADPO.REJECTED_DT,0)=0 THEN 'yellow_1' 
	ELSE 'gray' END)  AS  PO_DH_APPROVED_DT,
--hahah Sampai Sini
	HEADPR.PROD_MONTH,
    HEADPR.PR_NO, DETPR.PO_NO, 
    (CASE 
	WHEN ISNULL(DETPR.PO_NO,'') = '' THEN '0'
	WHEN HEADPO.PO_STATUS_FLAG = 'PO1' THEN '0'
	WHEN HEADPO.PO_STATUS_FLAG = 'PO2' THEN '0'
	WHEN HEADPO.PO_STATUS_FLAG = 'PO3' THEN '0'
	WHEN HEADPO.PO_STATUS_FLAG = 'PO5' THEN '0'
	--WHEN HEADPO.PO_STATUS_FLAG = 'PO6' THEN '0'
	ELSE 'pdf_icon' END) AS PDF,

  HEADPR.SH_APPROVED_BY AS PR_SH_APPROVED_BY2, HEADPR.SH_APPROVED_DT AS PR_SH_APPROVED_DT2, 
  HEADPR.DPH_APPROVED_BY AS PR_DPH_APPROVED_BY2, HEADPR.DPH_APPROVED_DT AS PR_DPH_APPROVED_DT2, 
  HEADPR.DH_APPROVED_BY AS PR_DH_APPROVED_BY2, HEADPR.DH_APPROVED_DT AS PR_DH_APPROVED_DT2, HEADPR.REJECTED_BY AS PR_REJECTED_BY,
  HEADPR.REJECTED_DT AS PR_REJECTED_DT, HEADPR.REJECTED_POSITION AS PR_REJECTED_POSITION, 
  HEADPR.CREATED_DT AS PR_CREATED_DT,
  HEADPR.CREATED_BY AS PR_CREATED_BY, 
  HEADPR.REMARK AS PR_REMARK, 
  HEADPO.SH_APPROVED_BY AS PO_SH_APPROVED_BY2, HEADPO.SH_APPROVED_DT AS PO_SH_APPROVED_DT2, 
  HEADPO.DPH_APPROVED_BY AS PO_DPH_APPROVED_BY2, HEADPO.DPH_APPROVED_DT AS PO_DPH_APPROVED_DT2, 
  HEADPO.DH_APPROVED_BY AS PO_DH_APPROVED_BY2, HEADPO.DH_APPROVED_DT AS PO_DH_APPROVED_DT2, HEADPO.REJECTED_BY AS PO_REJECTED_BY,
  HEADPO.REJECTED_DT AS PO_REJECTED_DT, HEADPO.REJECTED_POSITION AS PO_REJECTED_POSITION,
  HEADPO.CREATED_DT AS PO_CREATED_DT,
  HEADPO.CREATED_BY AS PO_CREATED_BY, 
  HEADPO.REMARK AS PO_REMARK, HEADPR.LP_CD, 
  TB_M_LOGISTIC_PARTNER.LOG_PARTNER_NAME,
  (CASE
   WHEN HEADPR.PR_STATUS_FLAG ='PR5' AND HEADPO.PO_STATUS_FLAG='PO1' THEN (SELECT SYSTEM_VALUE FROM TB_M_SYSTEM WHERE SYSTEM_CD = HEADPO.PO_STATUS_FLAG) 
   WHEN HEADPR.PR_STATUS_FLAG ='PR5' AND HEADPO.PO_STATUS_FLAG='PO2' THEN (SELECT SYSTEM_VALUE FROM TB_M_SYSTEM WHERE SYSTEM_CD = HEADPO.PO_STATUS_FLAG)
   WHEN HEADPR.PR_STATUS_FLAG ='PR5' AND HEADPO.PO_STATUS_FLAG='PO3' THEN (SELECT SYSTEM_VALUE FROM TB_M_SYSTEM WHERE SYSTEM_CD = HEADPO.PO_STATUS_FLAG)
   WHEN HEADPR.PR_STATUS_FLAG ='PR5' AND HEADPO.PO_STATUS_FLAG='PO4' THEN (SELECT SYSTEM_VALUE FROM TB_M_SYSTEM WHERE SYSTEM_CD = HEADPO.PO_STATUS_FLAG)
   WHEN HEADPR.PR_STATUS_FLAG ='PR5' AND HEADPO.PO_STATUS_FLAG='PO5' THEN (SELECT SYSTEM_VALUE FROM TB_M_SYSTEM WHERE SYSTEM_CD = HEADPO.PO_STATUS_FLAG)
   WHEN HEADPR.PR_STATUS_FLAG ='PR5' AND HEADPO.PO_STATUS_FLAG='PO6' THEN (SELECT SYSTEM_VALUE FROM TB_M_SYSTEM WHERE SYSTEM_CD = HEADPO.PO_STATUS_FLAG)
   WHEN HEADPR.PR_STATUS_FLAG= 'PR6' AND ISNULL(HEADPO.PO_STATUS_FLAG,'') ='' THEN (SELECT SYSTEM_VALUE FROM TB_M_SYSTEM WHERE SYSTEM_CD = HEADPR.PR_STATUS_FLAG)
   WHEN HEADPR.PR_STATUS_FLAG= 'PR5' AND ISNULL(HEADPO.PO_STATUS_FLAG,'') ='' THEN (SELECT SYSTEM_VALUE FROM TB_M_SYSTEM WHERE SYSTEM_CD = HEADPR.PR_STATUS_FLAG)
   WHEN HEADPR.PR_STATUS_FLAG= 'PR4' AND ISNULL(HEADPO.PO_STATUS_FLAG,'') ='' THEN (SELECT SYSTEM_VALUE FROM TB_M_SYSTEM WHERE SYSTEM_CD = HEADPR.PR_STATUS_FLAG)
   WHEN HEADPR.PR_STATUS_FLAG= 'PR3' AND ISNULL(HEADPO.PO_STATUS_FLAG,'') ='' THEN (SELECT SYSTEM_VALUE FROM TB_M_SYSTEM WHERE SYSTEM_CD = HEADPR.PR_STATUS_FLAG)
   WHEN HEADPR.PR_STATUS_FLAG= 'PR2' AND ISNULL(HEADPO.PO_STATUS_FLAG,'') ='' THEN (SELECT SYSTEM_VALUE FROM TB_M_SYSTEM WHERE SYSTEM_CD = HEADPR.PR_STATUS_FLAG)
   WHEN HEADPR.PR_STATUS_FLAG= 'PR1' AND ISNULL(HEADPO.PO_STATUS_FLAG,'') ='' THEN (SELECT SYSTEM_VALUE FROM TB_M_SYSTEM WHERE SYSTEM_CD = HEADPR.PR_STATUS_FLAG)
   END )AS PO_STATUS,
  --(SELECT SYSTEM_VALUE FROM TB_M_SYSTEM WHERE SYSTEM_CD = HEADPO.PO_STATUS_FLAG) AS PO_STATUS,
  (SELECT SYSTEM_VALUE FROM TB_M_SYSTEM WHERE SYSTEM_CD = HEADPR.PR_STATUS_FLAG) AS PR_STATUS,
	
	(CASE 
		WHEN ISNULL(HEADPO.PO_STATUS_FLAG,'') = '' AND HEADPR.PR_STATUS_FLAG= 'PR5' THEN 'B'
		WHEN ISNULL(HEADPO.PO_STATUS_FLAG,'') = '' AND HEADPR.PR_STATUS_FLAG= 'PR1' THEN 'C'
		WHEN ISNULL(HEADPO.PO_STATUS_FLAG,'') = '' AND HEADPR.PR_STATUS_FLAG= 'PR2' THEN 'C'
		WHEN ISNULL(HEADPO.PO_STATUS_FLAG,'') = '' AND HEADPR.PR_STATUS_FLAG= 'PR3' THEN 'C'
		--WHEN HEADPO.PO_STATUS_FLAG = NULL AND HEADPR.PR_STATUS_FLAG= 'PR4' THEN 'd'
		WHEN ISNULL(HEADPO.PO_STATUS_FLAG,'') = '' AND HEADPR.PR_STATUS_FLAG= 'PR6' THEN 'Z'
		WHEN HEADPO.PO_STATUS_FLAG ='PO1'  THEN 'A'
		WHEN HEADPO.PO_STATUS_FLAG ='PO2'  THEN 'C'
		WHEN HEADPO.PO_STATUS_FLAG ='PO3'  THEN 'C'
		--WHEN HEADPO.PO_STATUS_FLAG ='PO4'  THEN 'x'
		WHEN HEADPO.PO_STATUS_FLAG ='PO5'  THEN 'Z'
		WHEN HEADPO.PO_STATUS_FLAG ='PO6'  THEN 'C'
		ELSE 'X'
		END
	)AS STATUS

FROM
TB_M_LOGISTIC_PARTNER INNER JOIN
TB_R_DLV_PR_H AS HEADPR ON TB_M_LOGISTIC_PARTNER.LOG_PARTNER_CD = HEADPR.LP_CD LEFT OUTER JOIN
TB_R_DLV_PO_H AS HEADPO INNER JOIN
TB_R_DLV_PR_D AS DETPR ON HEADPO.PO_NO = DETPR.PO_NO ON HEADPR.PR_NO = DETPR.PR_NO

ORDER BY STATUS ASC;


SET @QUERY =' SELECT * FROM #TEMP_MONITORING WHERE 1=1';

IF @vPO_MONTH != '' SET @QUERY = @QUERY + ' AND PROD_MONTH IN (''' + @vPO_MONTH + ''')' 
IF @vPR_NO != '' SET @QUERY = @QUERY + ' AND PR_NO LIKE ''%' + @vPR_NO + '%'''
IF @vPO_NO != '' SET @QUERY = @QUERY + ' AND PO_NO LIKE ''%' + @vPO_NO + '%'''
IF @vPR_DATE != '' SET @QUERY = @QUERY + ' AND CAST(PR_CREATED_DT AS DATE) IN (''' + @vPR_DATE + ''')' 
IF @vPO_DATE != '' SET @QUERY = @QUERY + ' AND CAST(PO_CREATED_DT AS DATE) IN (''' + @vPO_DATE + ''')'
IF @vLOG_PARTNER_NAME != '' SET @QUERY = @QUERY + ' AND LP_CD IN (' + @vLOG_PARTNER_NAME + ')'
IF @vPR_STATUS != '' SET @QUERY = @QUERY + ' AND  PR_STATUS IN ('+ cast (@vPR_STATUS as varchar (max)) +')' 
IF @vPO_STATUS != '' SET @QUERY = @QUERY + ' AND  PO_STATUS IN ('+ cast (@vPO_STATUS as varchar (max)) +')'


IF (@vPO_MONTH <> '') OR (@vPR_NO <> '') OR (@vPO_NO <> '') OR (@vPR_DATE <> '') OR (@vPO_DATE <> '') OR (@vLOG_PARTNER_NAME <> '') OR (@vPR_STATUS <> '') OR (@vPO_STATUS <> '')



EXECUTE (@QUERY)


END

